<script lang="ts">
import Vue from 'vue';
import { DibGradientNumber, DibLineGraph } from './index.vue';

export default Vue.extend({
  name: 'DibPillar1Stats',
  components: {
    DibGradientNumber,
    DibLineGraph,
  },
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
});
</script>

<template>
  <SlpContainer class="stats">
    <section>
      <div class="header-content">
        <SlpTypography variant="heading2-bold" tag="h3" class="slp-mb-16">
          {{ data.subtitle }}
        </SlpTypography>
        <SlpTypography variant="heading5" tag="div" class="slp-mb-64">
          <div v-html="$md.render(data.text)" />
        </SlpTypography>
      </div>
      <div class="featured-data">
        <div class="gradient-number-container">
          <DibGradientNumber
            :number="data.featured_stat.number"
            :font-size="100"
            class="slp-mb-16"
          />
          <div class="label">
            <SlpTypography variant="heading5-bold" tag="div">
              {{ data.featured_stat.label }}
            </SlpTypography>
          </div>
          <div class="text">
            <SlpTypography variant="body1" tag="div">
              {{ data.featured_stat.text }}
            </SlpTypography>
          </div>
        </div>
        <div class="line-graph-container">
          <SlpTypography variant="heading5-bold" tag="p" class="slp-mb-24">
            {{ data.graph_header }}
          </SlpTypography>
          <DibLineGraph :data="data.graph" />
        </div>
      </div>
      <div class="circle-stats">
        <div v-for="item in data.stats" :key="item.text" class="circle">
          <div class="item">
            <DibGradientNumber :number="item.number" :font-size="80" />
          </div>

          <div class="text">
            <SlpTypography variant="heading5-bold" tag="div" class="grey">
              <span v-html="$md.render(item.label)"></span>
            </SlpTypography>
            <SlpTypography variant="heading5-bold" tag="div" class="quote">
              <span v-html="$md.render(item.text)"></span>
            </SlpTypography>
          </div>
        </div>
      </div>
    </section>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.stats {
  margin-top: 64px;
}
.header-content {
  h3 {
    display: block;
    max-width: 80%;
  }

  .slp-text-heading5 {
    display: block;
    max-width: 60%;
  }

  @media (max-width: $breakpoint-md) {
    h3,
    .slp-text-heading5 {
      max-width: 100%;
    }
  }
}

.featured-data {
  margin-top: 64px;
  display: flex;
  justify-content: space-between;
  flex-wrap: nowrap;
  gap: 24px;

  @media (max-width: $breakpoint-md) {
    flex-wrap: wrap;
  }

  .gradient-number-container {
    flex: 1 1 40%;

    @media (max-width: $breakpoint-md) {
      flex: 1 1 100%;
    }

    .gradient-number {
      margin-top: 64px;
    }

    .label {
      margin-top: 48px;
    }
    .text {
      margin-top: 24px;
      max-width: 300px;

      color: $color-text-200;

      @media (max-width: $breakpoint-md) {
        max-width: 100%;
      }
    }
  }
  .line-graph-container {
    flex: 0 1 60%;

    @media (max-width: $breakpoint-md) {
      flex: 1 1 100%;
    }
  }
}

.circle-stats {
  margin-top: 64px;
  margin-bottom: 96px;
  display: flex;
  gap: 64px;

  @media (max-width: $breakpoint-md) {
    flex-wrap: wrap;
  }

  .circle {
    position: relative;
    max-width: 330px;

    @media (max-width: $breakpoint-md) {
      margin-bottom: 32px;
      flex: 1 0 100%;
    }

    .gradient-number {
      z-index: 1;
      position: absolute;
      top: 30%;
      left: 10%;
    }

    .text {
      text-align: center;

      .grey {
        color: $color-text-200;
      }

      .quote {
        padding: 0 32px;

        @media (max-width: $breakpoint-md) {
          padding: 0;
        }
      }
    }

    .item {
      width: 200px;
      margin: 0 auto 24px auto;
      height: 200px;
      position: relative;
      border-radius: 50%;
      background: transparent;
      &:after {
        background: linear-gradient(
            93.78deg,
            rgba(227, 153, 93, 0.7) 8.53%,
            rgba(203, 146, 150, 0.7) 14.9%,
            rgba(127, 72, 214, 0.7) 95.91%
          )
          border-box;
        border: 1.5px solid transparent;
        width: 100%;
        height: 100%;
        border-radius: 50%;
        bottom: 0;
        content: '';
        left: 0;
        -webkit-mask:
          linear-gradient(#fff, #fff 0) padding-box,
          linear-gradient(#fff, #fff 0);
        -webkit-mask:
          linear-gradient(#fff 0 0) padding-box,
          linear-gradient(#fff 0 0);
        -webkit-mask-composite: xor;
        mask-composite: exclude;
        position: absolute;
        right: 0;
        top: 0;
      }
    }
  }
}
</style>
